import e, { createContext as Z, useContext as O, useMemo as P, useCallback as N, useRef as z, useEffect as L, useState as Y } from "react";
import { get as R, set as $, clone as X } from "radash";
import { usePointerDrag as J } from "react-use-pointer-drag";
import { SketchPicker as ee } from "react-color";
import te from "filesize";
const B = Z(void 0);
function S({ path: r, fallbackValue: o, onChange: i, errorPath: c, error: t }) {
  const n = O(B), a = P(() => (n == null ? void 0 : n.getValue(r)) ?? o, [n, r, o]), v = N((u) => {
    r && n && n.setValue(r, u), i == null || i(u);
  }, [r, n, i]);
  return t || (t = n == null ? void 0 : n.getError(c || r)), [a, v, t];
}
const ue = ({ values: r, errors: o, updateValues: i, onChange: c, onChangeValue: t, className: n, children: a }) => {
  const v = N((l) => l ? R(r, l) : void 0, [r]), u = N((l, E) => {
    t == null || t(l, E);
    const g = $(X(r), l, E);
    i == null || i(g), c == null || c(g);
  }, [r, i, c, t]), m = N((l) => o && l ? R(r, l) : void 0, [o]), s = P(() => ({ values: r, getValue: v, setValue: u, getError: m }), [r, v, u]);
  return e.createElement(
    B.Provider,
    { value: s },
    e.createElement("div", { className: "react-var-ui " + (n ?? "") }, a)
  );
}, I = ({ label: r, children: o, className: i, disabled: c, readOnly: t, column: n = !1, error: a }) => e.createElement(
  "div",
  { className: "react-var-ui-label " + (r ? "react-var-ui-label-has-label " : "react-var-ui-label-no-label ") + (c ? "react-var-ui-disabled " : "") + (t ? "react-var-ui-read-only " : "") + (n ? "react-var-ui-label-column " : "") + (i ?? "") },
  !!r && e.createElement("span", null, r),
  o,
  a ? e.createElement("div", { className: "react-var-ui-error" }, a) : null
), x = Math.PI * 2;
function T(r) {
  return (x + r % x) % x;
}
const ie = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, defaultValue: a = 0, className: v, error: u, errorPath: m }) => {
  const s = z(null), [l, E, g] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: u,
    errorPath: m
  }), d = P(() => Math.round(T(l) * (180 / Math.PI)), [l]), { dragProps: f } = J({
    onMove: ({ x: p, y: V }) => {
      if (!s.current)
        return;
      const w = s.current.getBoundingClientRect(), C = w.left + w.width / 2, h = w.top + w.height / 2;
      E(T(Math.atan2(V - h, p - C) + Math.PI / 2));
    }
  });
  return L(() => {
    var p;
    (p = s.current) == null || p.addEventListener("wheel", (V) => V.preventDefault());
  }, []), e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: v, error: g },
    e.createElement(
      "span",
      { className: "react-var-ui-angle-value" },
      d,
      "°"
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-angle" },
      e.createElement("div", { className: "react-var-ui-angle-control react-var-ui-interactive", ref: s, style: { transform: `rotate(${d}deg)` }, onDoubleClick: () => typeof a < "u" && E(a), onWheel: (p) => {
        E(T(l + 0.5 * (p.deltaY < 0 ? -1 : 1)));
      }, title: "Angle", ...f() })
    )
  );
}, se = ({ path: r, value: o, onChange: i, disabled: c, className: t, children: n, error: a, errorPath: v }) => {
  const [u, m, s] = S({
    path: r,
    fallbackValue: o,
    onChange: i,
    error: a,
    errorPath: v
  });
  return e.createElement("div", { className: "react-var-ui-array " + (c ? "react-var-ui-disabled " : "") + (t ?? "") }, u == null ? void 0 : u.map((l, E, g) => e.createElement(B.Provider, { value: {
    values: l,
    getValue: (d) => d ? R(l, d) : void 0,
    setValue: (d, f) => {
      const p = [...u];
      p[E] = $(X(l), d, f), m(p);
    },
    getError: (d) => {
      const f = s == null ? void 0 : s[E];
      return f && d ? R(f, d) : void 0;
    }
  }, key: E }, typeof n == "function" ? n(l, E, g) : n)));
}, me = ({ label: r, onClick: o, buttonLabel: i, disabled: c, className: t }) => e.createElement(
  I,
  { label: r, disabled: c, className: t },
  e.createElement(
    "span",
    { className: "react-var-ui-button" },
    e.createElement("button", { onClick: () => o == null ? void 0 : o(), disabled: c }, i)
  )
), ve = ({ label: r, path: o, value: i, onChange: c, alpha: t, disabled: n, readOnly: a, className: v, error: u, errorPath: m }) => {
  const [s, l, E] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: u,
    errorPath: m
  }), [g, d] = Y(!1), f = N(() => d((V) => !V), [d]), p = N(() => d(!1), [d]);
  return e.createElement(
    I,
    { label: r, disabled: n, readOnly: a, className: v, error: E },
    e.createElement(
      "span",
      null,
      e.createElement("span", { className: "react-var-ui-color-value" }, s),
      e.createElement(
        "div",
        { className: "react-var-ui-color react-var-ui-interactive" },
        e.createElement(
          "div",
          { className: "react-var-ui-color-swatch", onClick: f },
          e.createElement("div", { className: "react-var-ui-color-color", title: "Color preview", style: { background: s } })
        ),
        g ? e.createElement(
          "div",
          { className: "react-var-ui-color-popover" },
          e.createElement("div", { className: "react-var-ui-color-cover", onClick: p }),
          e.createElement(ee, { color: s, onChange: (V) => {
            const k = V.hex === "transparent" ? "#000000" : V.hex;
            if (t) {
              let w = Math.round((V.rgb.a ?? 1) * 255).toString(16);
              w.length === 1 && (w = "0" + w), l(k + w);
            } else
              l(k);
          }, disableAlpha: !t })
        ) : null
      )
    )
  );
}, de = ({ label: r, path: o, value: i, disabled: c, readOnly: t, className: n, error: a, errorPath: v, unit: u }) => {
  const [m, s, l] = S({
    path: o,
    fallbackValue: i,
    error: a,
    errorPath: v
  });
  return e.createElement(
    I,
    { label: r, disabled: c, readOnly: t, className: n, error: l },
    e.createElement(
      "span",
      null,
      m,
      u
    )
  );
}, j = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { d: "M.5 9.9a.5.5 0 0 1 .5.5v2.5a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1v-2.5a.5.5 0 0 1 1 0v2.5a2 2 0 0 1-2 2H2a2 2 0 0 1-2-2v-2.5a.5.5 0 0 1 .5-.5z" }),
  e.createElement("path", { d: "M7.646 1.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 2.707V11.5a.5.5 0 0 1-1 0V2.707L5.354 4.854a.5.5 0 1 1-.708-.708l3-3z" })
), Ee = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, className: a, accept: v, displayMetadata: u = !0, error: m, errorPath: s }) => {
  const [l, E, g] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: m,
    errorPath: s
  }), d = N((f) => {
    var V;
    if (!((V = f.target.files) != null && V.length))
      return;
    const p = f.target.files[0];
    E(p);
  }, [E]);
  return e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: a, error: g },
    e.createElement("span", { className: "react-var-ui-file-value" }, l == null ? void 0 : l.name),
    e.createElement(
      "div",
      { className: "react-var-ui-file react-var-ui-interactive" },
      u && !!l && e.createElement(
        "div",
        { className: "react-var-ui-file-metadata" },
        e.createElement(
          "div",
          null,
          "Size: ",
          te(l.size)
        ),
        e.createElement(
          "div",
          null,
          "Type: ",
          l.type || "unknown"
        )
      ),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: v, onChange: d, title: "File upload" })
    )
  );
}, fe = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, className: a, error: v, errorPath: u }) => {
  const [m, s, l] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: v,
    errorPath: u
  }), E = N((g) => {
    var p;
    if (!((p = g.target.files) != null && p.length))
      return;
    const d = g.target.files[0], f = URL.createObjectURL(d);
    s(f);
  }, [s]);
  return e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: a, error: l, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-image react-var-ui-interactive" },
      e.createElement("div", { className: "react-var-ui-image-background", style: {
        backgroundImage: m ? `url('${m}')` : void 0
      }, title: "Image preview" }),
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: "image/*", onChange: E, title: "Image upload" })
    )
  );
}, ge = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, className: a, acceptImage: v, acceptAudio: u, acceptVideo: m, error: s, errorPath: l }) => {
  const [E, g, d] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: s,
    errorPath: l
  }), [f, p] = Y(), V = P(() => {
    let h = "";
    return v && (h += "image/*,"), u && (h += "audio/*,"), m && (h += "video/*,"), h.endsWith(",") && (h = h.slice(0, -1)), h || (h = "image/*,audio/*,video/*"), h;
  }, [v, u, m]), k = N((h) => {
    var M;
    if (!((M = h.target.files) != null && M.length))
      return;
    const b = h.target.files[0], F = URL.createObjectURL(b);
    g(F);
  }, [g, p]), w = N(async (h) => {
    var F, M, D;
    if (!h) {
      p(void 0);
      return;
    }
    const b = await fetch(h);
    p((D = (M = (F = b == null ? void 0 : b.headers) == null ? void 0 : F.get("Content-Type")) == null ? void 0 : M.split("/")) == null ? void 0 : D[0]);
  }, [p]);
  L(() => {
    w(E);
  }, [E]);
  let C = e.createElement("div", { className: "react-var-ui-media-metadata" }, E ? "Unsupported file type." : "");
  switch (f) {
    case "image":
      C = e.createElement("div", { className: "react-var-ui-media-background", style: {
        backgroundImage: `url('${E}')`
      }, title: "Media preview" });
      break;
    case "video":
      C = e.createElement("video", { className: "react-var-ui-media-background", muted: !0, loop: !0, autoPlay: !0, src: E, title: "Media preview" });
      break;
    case "audio":
      C = e.createElement("audio", { className: "react-var-ui-media-audio", loop: !0, controls: !0, src: E, title: "Media preview" });
      break;
  }
  return e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: a, error: d, column: !0 },
    e.createElement(
      "div",
      { className: "react-var-ui-media react-var-ui-interactive" },
      C,
      e.createElement(j, null),
      e.createElement("input", { type: "file", accept: V, onChange: k, title: "Media upload" })
    )
  );
};
function q(r, o, i, c, t) {
  var a;
  isFinite(r) || (r = o ?? 0);
  let n = 2;
  return typeof c == "number" && (n = ((a = c.toString().split(".")[1]) == null ? void 0 : a.length) || 0, n > 20 && (n = 20), r = Math.round(r / c) * c), typeof o == "number" && (r = Math.max(o, r)), typeof i == "number" && (r = Math.min(i, r)), t ? Math.round(r) : parseFloat(r.toFixed(n));
}
const W = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M1.646 4.646a.5.5 0 0 1 .708 0L8 10.293l5.646-5.647a.5.5 0 0 1 .708.708l-6 6a.5.5 0 0 1-.708 0l-6-6a.5.5 0 0 1 0-.708z" })
), H = () => e.createElement(
  "svg",
  { xmlns: "http://www.w3.org/2000/svg", width: "16", height: "16", fill: "currentColor", viewBox: "0 0 16 16" },
  e.createElement("path", { fillRule: "evenodd", d: "M7.646 4.646a.5.5 0 0 1 .708 0l6 6a.5.5 0 0 1-.708.708L8 5.707l-5.646 5.647a.5.5 0 0 1-.708-.708l6-6z" })
), G = ({ value: r, onChange: o, min: i, max: c, step: t, className: n, disabled: a, readOnly: v, round: u, unit: m }) => {
  const s = z(null), l = N((d) => {
    s.current && (s.current.value = String(u(d))), o(d);
  }, [o, u]);
  L(() => {
    s.current && (s.current.value = String(r));
  }, [r]);
  const E = () => {
    const d = s.current;
    d && l(parseFloat(d.value));
  }, g = a || v ? {} : {
    onBlur: E,
    onKeyDown: (d) => {
      const f = s.current;
      switch (d.key) {
        case "ArrowUp":
          d.preventDefault(), l(parseFloat(f.value) + t);
          break;
        case "ArrowDown":
          d.preventDefault(), l(parseFloat(f.value) - t);
          break;
      }
    },
    onKeyUp: (d) => {
      d.key === "Enter" && (d.preventDefault(), E());
    }
  };
  return e.createElement(
    "div",
    { className: n },
    e.createElement("input", { type: "number", min: i, max: c, step: t, disabled: a, readOnly: v, ref: s, ...g }),
    m ? e.createElement("span", null, m) : null
  );
}, pe = ({ label: r, path: o, value: i, onChange: c, min: t, max: n, step: a = 1, integer: v, showButtons: u, disabled: m, readOnly: s, className: l, error: E, errorPath: g, unit: d }) => {
  const [f, p, V] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: E,
    errorPath: g
  }), k = N((h) => q(h, t, n, a, !!v), [t, n, a, v]), w = P(() => k(f), [f, k]), C = N((h) => {
    h = k(h), p(h);
  }, [k, p]);
  return e.createElement(
    I,
    { label: r, disabled: m, readOnly: s, className: l, error: V },
    e.createElement(
      "div",
      { className: "react-var-ui-number" },
      e.createElement(G, { className: "react-var-ui-number-input", round: k, min: t, max: n, step: a, value: w, disabled: m, readOnly: s, onChange: C, unit: d }),
      u && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: () => C(f + a), disabled: m || s },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: () => C(f - a), disabled: m || s },
          e.createElement(W, null)
        )
      )
    )
  );
}, Ve = ({ path: r, value: o, onChange: i, children: c, error: t, errorPath: n }) => {
  const [a, v, u] = S({
    path: r,
    fallbackValue: o,
    onChange: i,
    error: t,
    errorPath: n
  });
  return e.createElement(B.Provider, { value: {
    values: a,
    getValue: (m) => m ? R(a, m) : void 0,
    setValue: (m, s) => {
      const l = $(X(a), m, s);
      v(l);
    },
    getError: (m) => u && m ? R(u, m) : void 0
  } }, c);
}, he = ({ label: r, path: o, value: i, onChange: c, options: t, disabled: n, readOnly: a, className: v, error: u, errorPath: m }) => {
  const [s, l, E] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: u,
    errorPath: m
  }), g = P(() => JSON.stringify(s), [s]), d = !!t.find((f) => JSON.stringify(f.value ?? f.key) === g);
  return e.createElement(
    I,
    { label: r, disabled: n, readOnly: a, className: v, error: E },
    e.createElement(
      "div",
      { className: "react-var-ui-select" },
      e.createElement(
        "select",
        { onChange: (f) => l(JSON.parse(f.target.value)), value: g, title: "Select options", disabled: n || a },
        !d && e.createElement("option", { value: g }, String(s)),
        t.map((f) => {
          const p = JSON.stringify(f.value ?? f.key);
          return e.createElement("option", { key: f.key, value: p }, f.label);
        })
      )
    )
  );
}, ke = ({ label: r, path: o, value: i, onChange: c, min: t, max: n, step: a, integer: v, defaultValue: u, showInput: m, showButtons: s, disabled: l, readOnly: E, className: g, error: d, errorPath: f, unit: p }) => {
  const V = z(null), [k, w, C] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: d,
    errorPath: f
  }), h = N((y) => q(y, t, n, a, !!v), [t, n, a, v]), b = P(() => h(k), [k, h]), F = P(() => (b - t) / (n - t) * 100, [b, t, n]), M = N((y) => {
    w(h(y));
  }, [h, w]), D = N((y) => {
    if (!V.current)
      return;
    const K = V.current.getBoundingClientRect(), Q = (y - K.left) / K.width;
    M(t + (n - t) * Q);
  }, [M, v, t, n, a]), { dragProps: A } = J({
    onMove: ({ x: y }) => D(y)
  });
  return L(() => {
    var y;
    (y = V.current) == null || y.addEventListener("wheel", (U) => U.preventDefault());
  }, []), e.createElement(
    I,
    { label: r, disabled: l, readOnly: E, className: g, error: C },
    e.createElement(
      "div",
      { className: "react-var-ui-slider" },
      e.createElement(
        "div",
        { className: "react-var-ui-slider-track react-var-ui-interactive", ref: V, onClick: (y) => D(y.clientX), onDoubleClick: () => typeof u < "u" && M(u), onWheel: (y) => M(k - a * Math.sign(y.deltaY)), title: "Slider", ...A() },
        e.createElement("div", { className: "react-var-ui-slider-content", style: { width: F + "%" } })
      ),
      m ? e.createElement(G, { className: "react-var-ui-slider-input", round: h, min: t, max: n, step: a, disabled: l, readOnly: E, onChange: M, value: k, unit: p }) : e.createElement(
        "span",
        null,
        b.toString(),
        p
      ),
      s && e.createElement(
        e.Fragment,
        null,
        e.createElement(
          "button",
          { title: "Increase", onClick: () => M(k + a), disabled: l || E },
          e.createElement(H, null)
        ),
        e.createElement(
          "button",
          { title: "Decrease", onClick: () => M(k - a), disabled: l || E },
          e.createElement(W, null)
        )
      )
    )
  );
}, we = ({ label: r, path: o, value: i, onChange: c, maxLength: t, multiline: n, autoexpand: a, disabled: v, readOnly: u, className: m, error: s, errorPath: l }) => {
  const [E, g, d] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: s,
    errorPath: l
  }), f = (V) => {
    const k = V.currentTarget;
    k.style.height = "0", k.style.height = `${k.scrollHeight}px`;
  }, p = P(() => a ? { overflow: "hidden", resize: "none" } : void 0, [a]);
  return e.createElement(I, { label: r, disabled: v, readOnly: u, className: m, column: n, error: d }, n ? e.createElement("textarea", { className: "react-var-ui-string-multiline", value: E, onChange: (V) => g(V.target.value), onInput: a ? f : void 0, style: p, disabled: v, readOnly: u }) : e.createElement(
    "span",
    { className: "react-var-ui-string" },
    e.createElement("input", { type: "text", maxLength: t, value: E, onChange: (V) => g(V.target.value), disabled: v, readOnly: u })
  ));
}, Ne = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, className: a, error: v, errorPath: u }) => {
  const [m, s, l] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: v,
    errorPath: u
  });
  return e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: a, error: l },
    e.createElement(
      "span",
      null,
      e.createElement(
        "label",
        { className: "react-var-ui-toggle", title: "Toggle" },
        e.createElement("input", { type: "checkbox", checked: m, onChange: (E) => s(E.target.checked), disabled: t, readOnly: n }),
        e.createElement("span", { className: "react-var-ui-toggle-helper" })
      )
    )
  );
};
function _(r, o, i, c) {
  var n;
  const t = [0, 0];
  if (!r || !Array.isArray(r) || r.length < 2)
    return t;
  for (let a = 0; a < c.length; a++) {
    const v = ((n = c[a].toString().split(".")[1]) == null ? void 0 : n.length) || 0;
    t[a] = Math.round(r[a] / c[a]) * c[a], t[a] = Math.max(o[a], t[a]), t[a] = Math.min(i[a], t[a]), t[a] = parseFloat(t[a].toFixed(v));
  }
  return t;
}
function re(r, o, i) {
  if (!r)
    return [50, 50];
  const c = [0, 0];
  for (let t = 0; t < r.length; t++)
    c[t] = (r[t] - o[t]) / (i[t] - o[t]) * 100;
  return c;
}
const be = ({ label: r, path: o, value: i, onChange: c, disabled: t, readOnly: n, className: a, defaultValue: v = [0, 0], min: u = [-1, -1], max: m = [1, 1], step: s = [0.01, 0.01], error: l, errorPath: E }) => {
  const g = z(null), [d, f, p] = S({
    path: o,
    fallbackValue: i,
    onChange: c,
    error: l,
    errorPath: E
  }), V = P(() => _(d, u, m, s), [d, u, m, s]), k = P(() => re(V, u, m), [V, u, m]), w = N((b, F) => {
    if (!g.current)
      return;
    const D = g.current.getBoundingClientRect(), A = (b - D.left) / D.width, y = (F - D.top) / D.height, U = _([
      u[0] + (m[0] - u[0]) * A,
      u[1] + (m[1] - u[1]) * y
    ], u, m, s);
    f(U);
  }, [f, u, m, s]), { dragProps: C } = J({
    onMove: ({ x: b, y: F }) => w(b, F)
  }), h = N(() => {
    typeof v < "u" && f(v);
  }, [v, f]);
  return e.createElement(
    I,
    { label: r, disabled: t, readOnly: n, className: a, error: p },
    e.createElement(
      "span",
      { className: "react-var-ui-xy-value" },
      V[0],
      ", ",
      V[1]
    ),
    e.createElement(
      "div",
      { className: "react-var-ui-xy react-var-ui-interactive" },
      e.createElement(
        "div",
        { className: "react-var-ui-xy-space", ref: g, onClick: (b) => w(b.clientX, b.clientY), onDoubleClick: h, ...C() },
        e.createElement("div", { className: "react-var-ui-xy-control", style: { top: k[1] + "%", left: k[0] + "%" } })
      )
    )
  );
}, ye = ({ label: r, className: o, children: i, collapsible: c }) => {
  const [t, n] = Y(!1);
  return e.createElement(
    "div",
    { className: "react-var-ui-category " + (o ?? "") },
    e.createElement(
      "div",
      { className: "react-var-ui-category-title" },
      r,
      c && e.createElement("button", { title: t ? "Expand" : "Collapse", className: "react-var-ui-category-collapse", onClick: () => n((a) => !a) }, t ? e.createElement(W, null) : e.createElement(H, null))
    ),
    (!c || !t) && e.createElement("div", null, i)
  );
};
export {
  ie as VarAngle,
  se as VarArray,
  I as VarBase,
  me as VarButton,
  ye as VarCategory,
  ve as VarColor,
  de as VarDisplay,
  Ee as VarFile,
  fe as VarImage,
  ge as VarMedia,
  pe as VarNumber,
  Ve as VarScope,
  he as VarSelect,
  ke as VarSlider,
  we as VarString,
  Ne as VarToggle,
  ue as VarUI,
  be as VarXY,
  S as useVarUIValue
};
